C ===========================================================
	PROGRAM EXTDATA4d
C..............................................................Mar 2023
C Produce dGEC = (GEC-GECq)/GECq*100 % index
C..............................................................Aug. 2016
C GECq = Median for -15 days; 
C dGEC=(GEC-GECq)/GECq*100%; dGEC*=(GEC*-GECq)/GECq*100%
C                                                             ! Nov. 2011   
C   infile0, 1 ='d:\web\dat1\YY\moYRMN.txt'  
C   infile2='d:\web\graf\MA\ma155_2011XXXUT0000.SAO'
C   EXTRACT foF2 FROM DAILY-HOURLY FILE DPS SAO FILE, => infile2
c   EXTRACT 96 HOURLY "FOF2" from d:\web\dat1\YR\moyrmn.txt for 96 prec. hours => infile1
C               Send output results to d:\web\graf\dias\fof2-pred.txt files..= outfile1
C               Keep intermediate results in 'd:\web\graf\dias\fof2-96.txt' = outfile2
C   txt   fof2-pred.txt  fof2-96.txt     
c
      DIMENSION XF(0:96),IXF(4,0:96),XRES(0:23),IM(12)
     *,CC(15,0:23)
C-     +,dat(60)
     +,IXMD(16,3),rx(0:23),COEFA(74),COEFB(74),
     *FU1(24),FU2(24),FUA(5,24),FUB(5,24),
     *DA(5,0:23),IYMD(5,3) !4 prec_days+curr_day(5)
	+,XX(16,0:23)   ! 15 prec days for median,15-day for dGEC
C-      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre,jdy_pre
      INTEGER med(0:23),IDG(0:23),ires(0:23)
      CHARACTER*120 infile0,infile1,outfile    ! WGEC index
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
 	CHARACTER*2 AMN,DD1,DD2,AYR,ADY
     *,PYR_pre,PMN_pre                              
	COMMON /BL2/CC,MED
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA COEFA/
     &.2588190, .5, .7071068, .8660254, .9659258,1.0,.9659258,.8660254
     &, .7071067, .5, .2588190, .0,-.2588191,-.5,-.7071068,-.8660254,
     &-.9659259,-1.0,-.9659258,-.8660253,-.7071066,-.5,-.2588189, .0
     &,.5,.8660254,1.0,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5
     &,.0, .7071068, 1.0, .7071067, .0,-.7071068,-1.0,-.7071066, .0      
     &, .8660254, .8660254, .0,-.8660254,-.8660253, .0
     &,.9659258,.5,-.7071068,-.8660253,.2588192,1.0,.2588188,-.8660256
     &,-.7071065, .5, .9659257,.0,-.9659259,-.5, .7071072,.8660251
     &,-.2588196,-1.0,-.2588184, .8660257, .7071062,-.5,-.9659256, .0/
	DATA COEFB/
     &.9659258, .8660254, .7071068, .5, .2588190, .0,-.2588191,-.5
     &,-.7071068,-.8660254,-.9659259,-1.0,-.9659258,-.8660253,-.7071067
     &,-.5,-.2588189,.0, .2588192,.5,.7071069, .8660255, .9659259, 1.0     
     &,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5,.0,.5,.8660255
     &,1.0, .7071068, .0,-.7071068,-1.0,-.7071067, .0, .7071069, 1.0
     &, .5,-.5,-1.0,-.5, .5, 1.0
     &, .2588190,-.8660254,-.7071067, .5, .9659258, .0,-.9659259,-.5
     &,.7071070,.8660252,-.2588194,-1.0,-.2588186,.8660257,.7071064,-.5
     &,-.9659257, .0, .9659260, .5,-.7071073,-.8660250, .2588198, 1.0/
C
C  Re-arrange coefficients for Ai, Bi:
	DO JCASE=1,5
	select case (jcase)
	case (1)
    	do i=1,24
    	fu1(i)=coefa(i)
	fu2(i)=coefb(i)
	enddo
	goto 6
	case (2)
    	do i=1,12 
      fu1(i)=coefa(i+24)
      fu1(i+12)=fu1(i)
	fu2(i)=coefb(i+24)
	fu2(i+12)=fu2(i)
	enddo
	goto 6
	case (3)
    	do i=1,8 
    	fu1(i)=coefa(i+36)
	fu1(i+8)=fu1(i)
	fu1(i+16)=fu1(i)
	fu2(i)=coefb(i+36)
	fu2(i+8)=fu2(i)
	fu2(i+16)=fu2(i)
	enddo
	goto 6
	case (4)
    	do i=1,6 
    	fu1(i)=coefa(i+44)
	fu1(i+6)=fu1(i)
	fu1(i+12)=fu1(i)
	fu1(i+18)=fu1(i)
	fu2(i)=coefb(i+44)
	fu2(i+6)=fu2(i)
	fu2(i+12)=fu2(i)
	fu2(i+18)=fu2(i)
	enddo
	goto 6
	case (5)
    	do i=1,24
    	fu1(i)=coefa(i+50)
	fu2(i)=coefb(i+50)
	enddo
	goto 6
	end select
C
    6		do nn=1,24
      FUA(jcase,nn)=fu1(nn)
	FUB(jcase,nn)=fu2(nn)
	enddo
	ENDDO
C Start:
C    
C
C read preceding 96 values: iyr,imn,idy,iut,GEC
C
C
c	 Next lines = specify path and name of Output file:
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
       TTT(1:4)=TT(1:4)								 !Ljuba
	YEAR=DD(1:4)									 !Ljuba
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT !Tamara

C-       timefile='/var/www/izmiran/ionosphere/weather/graf/UT_time'
   50	FORMAT(A4,1x,A2,1x,A2,1x,A3,1x,A2,1x,A4,1x,A2,1x,A2,1x,A3,A10)
C+       OPEN(13,FILE=timefile,STATUS='OLD')
C+       read (13,50)YEAR,AMN,DD2,DOYpre,AUT,YEARbeg,PMN_pre,DD3,DOYbeg       !Ljuba YEAR ,,,,UT - , 
C+       close(unit=13)                                                       !Ljuba AYR ,,, -   
C	WRITE(*,*) 'Reading file UT_time: YEAR=',YEAR, ' AMN=', AMN,' DD2=', DD2,' DOYpre=', DOYpre, ' AUT=', AUT  
C	WRITE(*,*) ' YEARbeg=',YEARbeg, ' PMN_pre=', PMN_pre, ' DD3=', DD3, ' DOYbeg=',DOYbeg  

	write(*,*) ' Enter YEAR' 							!  Ljuba	 !Tamara
	read(*,*) YEAR								!  Ljuba	 !Tamara
	read(YEAR,*) ryear
	iyear=int(ryear)
C            TTT(1:4)=YEAR                                                   !Ljuba   =YEAR     UT_time .
      write(*,*) ' Enter MN1 '
	read(*,*) jmn1 			       !  Ljuba	 !Tamara
CC+++++++++++++++++++++
C        DO 1230 iyear=1995,2022
	jyr=iyear-iyear/100*100
	call blet2(jyr,AYR)
C	AYR=YEAR(3:4)                                                         !  Ljuba
       write(*,*) ' AYR=YEARbeg(3:4) = ', AYR
	pyr_pre=AYR ! prec_year
C	read(ayr,*) ryr
       ryr=float(jyr)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C! ++	jmn=0		 ! ++
C
111	CONTINUE
CC----------------------------------
C       jmn1=1  !TEMPPPPPPP
       jmn2=12
	if (iyear.eq.2023) jmn2=2 !TEMPPPPPPPPPPPP
       DO 1240 jmn=jmn1,jmn2
	call blet2(jmn,AMN)
CC
CC
       kdy1=1
	kdy2=im(jmn)
	call blet2(kdy1,dd1)
	call blet2(kdy2,dd2)
       jut=0			!Furie prediction for current day UT=00,...,23
	ut=float(jut)

C
C preceding month:
	if (jmn.gt.1) then
	jmn_pre=jmn-1			 ! prec_mn
      jyr_pre=jyr
	PYR_pre=AYR
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=jyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
C
C
  134  CONTINUE
c
C
C	infile0='d:\web\dat1\YY\moYRMN.txt'   ! preceding mn      !Tamara
C-	infile0='d:\web\dat0\YY\eoYRMNj.txt'   ! preceding mn      !Tamara
	infile0='d:\web\dat0\YY\ghYRMN.txt'   ! preceding mn      !Tamara
	infile0(13:14)=pyr_pre										 !Tamara
 	infile0(18:19)=pyr_pre										 !Tamara
	infile0(20:21)=pmn_pre										 !Tamara
	 infile1=infile0  ! current mn
	infile1(13:14)=ayr										 !Tamara
 	infile1(18:19)=ayr										 !Tamara
	infile1(20:21)=amn										 !Tamara
	OUTFILE='d:\web\dat0\YY\dgecYR.txt' !		 dGEC ~ -15d median
	OUTFILE(13:14)=ayr
	OUTFILE(20:21)=ayr
C=	OPEN(11,file=outfile3,access='APPEND')
	OPEN(11,file=outfile,access='APPEND') ! EGEC
C =======================================================
	DO 77 kdy=kdy1,kdy2
	call blet2(kdy,ADY)
CREM Avoid input of prec. month if current day >4
C Avoid input of prec. month if current day >15 For -15 days median
CREM	if (kdy2.gt.4) GOTO 130						 !!!
	if (kdy.gt.15) GOTO 130						 !!!
C =======================================================
C
  117	FORMAT(3I2,2X,24(F3.0,2X))		   
C
C  day-to-day input for prec mon
C
	nndy=im(jmn_pre)	  ! prec. mn
		OPEN(10,FILE=INFILE0)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	DO jdy_pre=1,nndy  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=116) iiy,iim,iid,(rx(k),k=0,23)
	 ixmd(16,1)=iiy
	ixmd(16,2)=iim
	ixmd(16,3)=iid
	do k=0,23
	XX(16,k)=rx(k)
	enddo
C move data up by 1 line
	do jj=1,15
	do j=1,3
	ixmd(jj,j)=ixmd(jj+1,j)
	enddo
	do k=0,23
	XX(jj,k)=XX(jj+1,k)
	enddo
	enddo
      ENDDO
  116	close(unit=10)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C input for current mn
  130	continue
C
		OPEN(10,FILE=INFILE1)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	kk=0
	DO jdy=1,kdy  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,23)
	 ixmd(16,1)=iiy
	ixmd(16,2)=iim
	ixmd(16,3)=iid
	do k=0,23
	XX(16,k)=rx(k)
	enddo

	kk=kk+1
	if (kk.lt.kdy) then

C move data up by 1 line
	
	do jj=1,15
	do j=1,3
	ixmd(jj,j)=ixmd(jj+1,j)
	enddo
	do k=0,23
	XX(jj,k)=XX(jj+1,k)
	enddo
	enddo
	endif
  	ENDDO
  118	close(unit=10)
C+
      DO k=1,15
	  do kut=0,23
	CC(k,kut)=XX(k,kut)
	  enddo
	ENDDO
       call rmedian15(15) ! median for -15 prec. days	 =>MED(0:23)
C
C=	write(*,86) ayr,amn,ady,(med(k),k=0,23)
C=	write(13,86) ayr,amn,ady,(med(k),k=0,23)
C+	  Data for 4 prec. days + current day=5
C
      do nn=1,5
	iymd(nn,1)=ixmd(nn+23,1)
	iymd(nn,2)=ixmd(nn+23,2)
	iymd(nn,3)=ixmd(nn+23,3)
	do kk=0,23
	DA(nn,kk)=XX(nn+23,kk)
	enddo
	enddo
C re-arrange data for 96 prec. hours:
	kk=0
C
	 kut=jut
	jj1=1
	jjend=4
  123	IXF(1,kk)=iymd(jj1,1)
	IXF(2,kk)=iymd(jj1,2)
	IXF(3,kk)=iymd(jj1,3)
	IXF(4,kk)=kut
      XF(kk)=da(jj1,kut)
	kk=kk+1
	if (kk.gt.95) goto 124
	kut=kut+1
	if (kut.gt.23) then
	kut=0
	jj1=jj1+1
	if (jj1.gt.5) goto 124
	endif
	goto 123
C
 124	call subfur(xf,xres) ! Furie results for UT=00,...,23 on current day (16) =>xres
	DO kk=0,23
C=	IDG(KK)=NINT((XX(28,KK)-XRES(KK))/XRES(KK)*1000.)
	delog=0.
	 xpar=XX(16,KK)
C+++	xmed=XRES(KK)
      xmed=float(MED(KK))
C	call windex(xpar,xmed,delog,iw)           !WGEC
       dgec=(xpar-xmed)/xmed*1000.		! %*10
C	IDG(kk)=iw
	IDG(kk)=nint(dgec)
	ENDDO
	write(*,86) AYR,AMN,ADY,(idg(k),k=0,23)	   !WGEC
	write(11,86) AYR,AMN,ADY,(idg(k),k=0,23)	!WGEC
   86	format(3A2,24(1X,I4))
C
  135	CONTINUE
C-      kdy=kdy2	 ! current day from GEC file
C
c ==========================================================
c
C   17	FORMAT(1X,A3)  ! Ljuba -  FORMAT(1X,'DOY='A3)

   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A120)
C
C
C
   1	continue
C ===================================
C
	xfof2=xres(jut)             ! xres(0)?
C new array ===============
C=	ixf(1,96)=jyr
C=	ixf(2,96)=jmn
C=	ixf(3,96)=jdy
C=	ixf(4,96)=jut
C=	xf(96)=xfof2
C Shift 96 values by 1 h up:
C=	do n=1,96
C=	do k=1,4
C=	ixf(k,n-1)=ixf(k,n)
C=	enddo
C=	xf(n-1)=xf(n)
C=	enddo
C-	call subfur(xf,xres)
C ========================================
   11	continue
C-  440 CLOSE (unit=11)
C Output of foF2-pred.txt
C=	OUTFILE1='d:\web\dat0\ghYR-pred.txt' !
C=	OUTFILE1(15:16)=AYR
C-       OUTFILE1='/var/www/izmiran/ionosphere/weather/graf/f/fof2-pred'  ! Liuba
C=	OPEN(12,FILE=OUTFILE1,access='APPEND')
	kut=jut
C-	kdy=jdy
	do kk=0,23
C-	kut=kut+1
C-	if (kut.gt.23) then
C-	kut=0
C-	kdy=kdy+1
C-	endif
	ires(kk)=nint(xres(kk))
	fpred=xres(kk)	  ! Check
	enddo
C=	write(*,86) ayr,amn,ady,(ires(k),k=0,23)
C=	write(12,86) ayr,amn,ady,(ires(k),k=0,23)
C=	close(unit=12)
   87	format(4(I2,1X),1X,F5.1)					!NEW
C Keep updated outfile2:
C??	outfile2='d:\web\dat0\eo-96.txt'
C       outfile2='/var/www/izmiran/ionosphere/weather/graf/f/fof2-96'
C+		OPEN(12,file=outfile2)
C+	do nn=1,96
C+	ifof2=nint(xf(nn-1))
C+	write(*,88) (IXF(k,nn-1),k=1,4),ifof2
C+	write(12,88) (IXF(k,nn-1),k=1,4),ifof2
C+	enddo
C+	    CLOSE (unit=12)
   77 continue                 ! go to the next day
   88	format(4(I2,1X),1X,I3)					!NEW
C End of  ===============
C Add output to graf/2011/mo11f.br including sout(*), mo11h.br ++++++++++++
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 1240	CONTINUE
   2  	 CLOSE (unit=11)
	CLOSE (unit=13)
 1230	CONTINUE
C	IF (jmn.lt.12) GOTO 111
  112	pause ' '       ! Liuba 
	STOP            ! Liuba 
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
C-	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
C	a3='000'  ! Ljuba  a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C
C Convert numeric parameter ilet to character alet
C
      subroutine blet4(ilet,alet4)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
		DATA IN/'0','1','2','3','4','5','6','7','8','9'/
      CHARACTER*4 alet4
	alet4=' 000'
C
   1		j1000=ilet/1000
	      j100=(ilet-j1000*1000)/100
	j10=(ilet-j1000*1000-j100*100)/10
	j1=ilet-j1000*1000-j100*100-j10*10
	do i=0,9
		if (j1000.eq.i) then
	 alet4(1:1)=IN(i)
	endif
	enddo
	if(alet4(1:1).eq.'0') alet4(1:1)=' '
    3	do i=0,9
		if (j100.eq.i) then
	 alet4(2:2)=IN(i)
	endif
	enddo
c	if((alet4(1:1).eq.' ').and.(alet4(2:2).eq.'0')) alet4(2:2)=' '
    5	do i=0,9
	if (j10.eq.i) then
	alet4(3:3)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet4(4:4)=IN(i)
	endif
	enddo 
	return
	end
C
C
C================================================================
      subroutine subfur(fdat,fres)
C.......................................................Nov. 2011
C Furie expansion of diurnal foF2 using 96 prec. values 
      dimension fdat(0:96),fres(0:23),
     *AI(5),BI(5),FUA(5,24),FUB(5,24)
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie for Ai, Bi
	PARAMETER (n=96,p=24.,pip=.2617994)
C
C Parameters:
c	PI=ATAN(1.0)*4.
c	P=24.
c	N=96
c	 pip=2*pi/p 
C
crem
C mean of 96 values:
	xav=0.
	do i=0,N-1
	xav=xav+fdat(i)
	enddo
	xav=xav/N
C
	do ii=1,5
	  ai(ii)=0.
	  bi(ii)=0.
	  DO nn=1,4  ! 4 times repeat coefs. for Ai and Bi
	     do j=1,24  ! set of coefficiens
	       nj=j-1+(nn-1)*24
	       xval=fdat(nj)
c
	       ai(ii)=ai(ii)+xval*fua(ii,j)
	       bi(ii)=bi(ii)+xval*fub(ii,j)
	     enddo
	  ENDDO
	  ai(ii)=ai(ii)*2./N
	  bi(ii)=bi(ii)*2./N
	enddo
C synthesis
		sum=xav
	do iut=0,23
	fres(iut)=xav
	do ii=1,5
	fres(iut)=fres(iut)+ai(ii)*fua(ii,iut+1)+
     *bi(ii)*fub(ii,iut+1)
	 enddo
	enddo
  101	CONTINUE
crem	close (unit=15)
	RETURN
	end

C ===============================================================
      integer function ndoy(iyr,imn,idy)
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
