C ===========================================================
	PROGRAM EXTGECMP
C                                                             ! May 2013   
C
C Change proxy to Rzp=1+int(Rzm/3),
C      	  Rzm=(Rz(3)av + Rz(-7)av +Rz(-81)av)/3
C
C   EXTRACT daily-mean GEC, for 12 months @ 40 grids od Rzi=1,2,...,40 (Rzi>40 joint to Rzi=40) 
C   Input <gechYR.jrc  => infile
C         <arzsci.txt> => infilerz
C
C   Output
C   (1) outfile: GRZI(40,12) (2) outfile0: GRZI0(40,12) (3) outfile1: GRZI1(40,12)
c
      DIMENSION IM(12),RES(12),RES0(12),RES1(12),RINP(0:83)
	+,grzi0(12,40),grzi1(12,40),grzi(12,40),cnt(12,40)
      INTEGER*2 jyr,jmn,jdy
      CHARACTER*128 infile,outfile,infilerz,outcnt, outfilerzp
	+,outfile0,outfile1 ! North and South mag.hemisphere
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
 	CHARACTER*2 AYR,AMN,ADY,PMN,PDY,BMN,BDY
	CHARACTER*4 AYEAR,PYEAR,BYEAR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C Start:
	outfile='gecrzp.txt'
	outfile0='gecrzp0.txt'
	outfile1='gecrzp1.txt'
	outcnt='gecrcntp.txt'
	outfilerzp='arzscip.txt'

		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
	do i=1,12
	do k=1,40
	grzi(i,k)=0.
	grzi0(i,k)=0.
	grzi0(i,k)=0.
	cnt(i,k)=0.
	enddo
	enddo
C
   80	format(1X,A4,2A2,1X,I3)
   78	format(1X,A4,2A2,5(1X,I3)) ! output rz3,...,rzp
C
	infile='gechYR.jrc'
	iflag=0           ! before 1999
	BYEAR='0000'
	BMN='00'
	BDY='00'
C
C GO TO USAGE OF PROXY RZP
	GOTO 172  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
	OPEN(10,FILE=outfilerzp)
C
C  Read Rzi lines before 1999:
	infilerz='arzsci.txt'
	OPEN(11,FILE=INFILERZ)
	irun=0
   70	read(11,80,end=170) AYEAR,AMN,ADY,irz          ! read lines before 1999
	irun=irun+1
	rinp(83)=float(irz)
	if (irun.le.83) then
C Move data up line-by-line
	do k=1,83
	rinp(k-1)=rinp(k)
	enddo
C Preceding day for Rzp-proxy:
	PYEAR=BYEAR
	PMN=BMN
	PDY=BDY

	BYEAR=AYEAR
	BMN=AMN
	BDY=ADY
	goto 70
	endif
C Proxy Rzp for :
	rz3=(rinp(80)+rinp(81)+rinp(82))/3.
	rz7=0.
	do k=74,80
	rz7=rz7+rinp(k)
	enddo
	rz7=rz7/7.
	rz81=0
	do k=0,80
	rz81=rz81+rinp(k)
	enddo
	rz81=rz81/81.
	rzav=(rz3+rz7+rz81)/3.
	irzp=1+int(rzav/5.)
	irz3=int(rz3) 
	irz7=int(rz7) 
	irz81=int(rz81)
	irzav=int(rzav)
C output of Rzp starting from 1850
	write(*,78) pyear,pmn,pdy,irz3,irz7,irz81,irzav,irzp
	write(10,78) pyear,pmn,pdy,irz3,irz7,irz81,irzav,irzp
C
C Move data up by 1 line:
	irun=irun-1
	do k=1,83
 	rinp(k-1)=rinp(k)
	enddo
C Preceding day for Rzp-proxy:
	PYEAR=BYEAR
	PMN=BMN
	PDY=BDY

	BYEAR=AYEAR
	BMN=AMN
	BDY=ADY
	GOTO 70
  170	close(unit=11)
	stop
C =========================================================
   77	format(1X,I4)
  172	OPEN(11,FILE=outfilerzp,ACTION='READ')
  171	read(11,77) iyrz
C
	if (iyrz.lt.1999) then
	goto 171
	else
	backspace(11)
	endif
C
	icntot=0
C
C Cycle on year-to-year 1999-2012:
       DO 71 iyyyy=1999,2012
C
	jyr=iyyyy-(iyyyy/100)*100
	call blet2(jyr,AYR)
	infile(5:6)=AYR
	OPEN(12,FILE=INFILE,ACTION='READ')
C
	ryr=float(jyr)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

C cycle on month-to-month
	DO jmn=1,12
	nmax=im(jmn) 
C day-to-day cycle
   81 format(3X,3I2,6X,I2)
  181 format(3X,3I2,18X,I2)   ! Change to Rzp !!!!!!!!!!!!!
   82 format(3I2,40X,3(3X,F3.2))
	do jdy=1,nmax
C read Rzi
	read(11,181,end=73) iyrz,imnz,idyz,irzi ! read Rzi
	if (irzi.gt.40) irzi=40
C read daily GEC, GEC0, GEC1
	read(12,82,err=3,end=79) iyrg,imng,idyg,gec,gec0,gec1 ! read GEC
	if ((iyrz.eq.iyrg).and.(imnz.eq.imng).and.(idyz.eq.idyg)) then
	icntot=icntot+1
	cnt(jmn,irzi)=cnt(jmn,irzi)+1.
	grzi(jmn,irzi)=grzi(jmn,irzi)+gec
	grzi0(jmn,irzi)=grzi0(jmn,irzi)+gec0
	grzi1(jmn,irzi)=grzi1(jmn,irzi)+gec1
	endif
	enddo     ! end daily cycle
	ENDDO			 ! end monthly cycle
   79	close(unit=12)

   71	CONTINUE ! END year-to-year cycle
   73	close(unit=11)
C
		OPEN(13,FILE=OUTFILE)
	OPEN(14,FILE=OUTFILE0)
	OPEN(15,FILE=OUTFILE1)
	OPEN(16,FILE=outcnt)
C
	do k=1,40
	do i=1,12
	if (cnt(i,k).gt.0.) then
	res(i)=grzi(i,k)/cnt(i,k)
	res0(i)=grzi0(i,k)/cnt(i,k)
	res1(i)=grzi1(i,k)/cnt(i,k)
	endif
	enddo
C Output 
	write(*,87) (res(i),i=1,12)
	write(13,87) (res(i),i=1,12)
	write(*,87) (res0(i),i=1,12)
	write(14,87) (res0(i),i=1,12)
	write(*,87) (res1(i),i=1,12)
	write(15,87) (res1(i),i=1,12)
	write(*,88) (cnt(k,i),i=1,12)
	write(16,88) (cnt(k,i),i=1,12)
	enddo

C
C
C ===================================
   87	format(12(1X,F6.2))
   88	format(12(1X,F6.0))

C
C ========================================
C

	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
   2      CLOSE (unit=13)
       CLOSE (unit=14)
	    CLOSE (unit=15)
	CLOSE (unit=16)
	pause ' '
	STOP
	END
C
C ===============================================================
