C........................................................Apr 2023
C Produce catalog Apo-peak, t(dGEC+),t0,t(dGec-),dGECmax+,dGECmin-
C
C Extract dGEC  for -12h<t0< +36h for 236 Apo > 100 nT events 1995-2023
C
C........................................................Mar. 2023
C 
C t0 at Apo >=100nT storm peak
C
C Extract dGEC  for -12h<t0< +36h for Apo events (t0 at Apo > 100 nT)
C 
C Select period of 48hrs starting from t0-12h, ending t0+35h; 
C 
      PROGRAM extpeak48
C Input HSSUT.txt 1995-2023...........................Jan 2020
C
C----------------------------------------------------------------
C
	DIMENSION inpn(0:71) ! 1h indices for 24h (or 72h file for 1h indices)
C	+,ind24(0:23)
C
      CHARACTER*128 INFILE,INFHSS
	+,outfile  !
	 CHARACTER*20 start
		 CHARACTER*2 AMN,ADY,AUT
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
C
	infile='dgec2d12.txt' !dGEC total file for 1995-2023 Apo-storms =nev lines x 48 cols superposed epoch	! 3
  	infhss='Apostorm12.txt'  ! Apo storms Apo>=100 nT
	outfile='catapodgec.txt'
C
C Start 
C
    1	CONTINUE
C
    7	OPEN(11,FILE=OUTFILE)
C
   28 format(1X,F8.3,3(1X,I2),3(1X,F6.0))
   29 format(A20,1X,I4,3(1X,I2),1X,F5.0)
   38 format(48(1X,I4))
C
	open(10,file=infhss,action='READ')
	open(15,file=infile,action='READ') ! dGEC(t) -12h...t0...t0+35h
C
C
C Cycle on events ====================================================
C
       	nev=236 ! intense Apo storms	
C
	DO 177 iev=1,nev
      read(10,29,end=27) start,iyear,imn1,idy1,iut1,aep
	read(15,38,end=103) (inpn(k),k=0,47)
C
       call blet2(imn1,AMN)
	call blet2(idy1,ADY)
	call blet2(iut1,AUT)
	iyr=iyear-iyear/100*100
C
	lda1=ndoy(iyr,imn1,idy1) ! 1d
	ryear=float(iyear)
		if(int(ryear/4.)*4.eq.iyear) THEN 
	ndnyr=366
	                          ELSE
	ndnyr=365
	ENDIF
	del=1./ndnyr
	xyear=ryear+(lda1-1)*del
	kapot0=13         ! peak Apo
C
C peak dGEC+
       kdmax=0
	ktmax=0
       do k=0,24
	if (inpn(k).gt.kdmax) then
	ktmax=k
	kdmax=inpn(k)
	endif
	enddo
C
C min dGEC-
       kdmin=0
	ktmin=0
       do k=ktmax,35
	if (inpn(k).lt.kdmin) then
	ktmin=k
	kdmin=inpn(k)
	endif
	enddo
C
C t0 at intesection dGEC+ and dGec-
	kt0=kapot0
	do 123 k=ktmax,ktmin-1
	if (inpn(k)*inpn(k+1).le.0) then
	if (inpn(k).eq.0) then
	kt0=k
	exit
               else
	kt0=k+1
	endif
	                             endif
  123	continue
	kdtmax=ktmax-kapot0
	kdtmin=ktmin-kapot0
	kdt0=kt0-kapot0
C
C Output catalog
      dmax=kdmax/10.
	dmin=kdmin/10.
      write(*,37) xyear,lda1,AMN,ADY,AUT,aep,kdtmax,kdt0,kdtmin
	+,dmax,dmin,iev
      write(11,37) xyear,lda1,AMN,ADY,AUT,aep,kdtmax,kdt0,kdtmin
	+,dmax,dmin,iev
  177	CONTINUE
   27 close(unit=10)
  103	close(unit=15)
      close(unit=11)
C
   37	format(1X,F8.3,1X,I3,3(1X,A2),1X,F5.0,3(1X,I3),2(1X,F5.1),1X,I3)
C
   35      write(*,*) infile
      pause ' ' 
      STOP
       END

C***********************************************************
