C ===========================================================
	PROGRAM FITGECM3
C
C Change proxy to Rzp=1+int(Rzm/3),
C      	  Rzm=(Rz(3)av + Rz(-7)av +Rz(-81)av)/3
C
C 
C                                                             ! May 2013   
C
C   Fitting daily-mean GEC, for 12 months @ 40 grids for Rzi=1,2,...,40 (Rzi>40 joint to Rzi=40) 
C   Input 
C         <arzsci.txt> => infilerz
C
C   Output
C   (1) outfile: FITgecmh.txt = infilerz+gecfit(Rzi) 
c
      DIMENSION IM(12)
      INTEGER*2 jyr,jmn,jdy
	INTEGER*4 iyyyy
      CHARACTER*128 outfile,infilerz
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
 	CHARACTER*2 AYR,AMN,ADY
	CHARACTER*4 AYEAR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C Start:
	outfile='fitgecmh.txt'
		OPEN(12,FILE=OUTFILE)
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
C
   80	format(1X,I4)
C

C  Read Rzi lines before 1999:
	infilerz='arzsci.txt'
	OPEN(11,FILE=INFILERZ)
C
C Cycle on year-to-year 1849-2012:
       DO 71 iyyyy=1849,2012
C
C
	ryr=float(iyyyy)
	if(int(ryr/4.)*4.eq.iyyyy) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

C cycle on month-to-month
	DO kmn=1,12
	nmax=im(kmn) 
C day-to-day cycle
   81 format(1X,A4,2A2,1X,I3,1X,I3)
   82 format(1X,A4,2A2,1X,I3,1X,I3,1X,F6.3)
	do kdy=1,nmax
C read Rzi
	read(11,81,end=73) ayear,amn,ady,irz,irzi ! read Rzi
	ayr=ayear(3:4)
	read(ayr,*) xyr
	jyr=int(xyr)
	read(amn,*) xmn
	jmn=int(xmn)
	read(ady,*) xdy
	jdy=int(xdy)
	rzi=float(irzi)
	if (rzi.gt.40.) rzi=40.
C Day-of-year:
	lda=ndoy(jyr,jmn,jdy) 
	days=float(lda)/ndnr*360. ! Day-of-year scaled to 360.
C 12 monthly coefficients refers to 1:360 days:
C days=15,45,75,105,135,165,195,225,255,285,315,345
C month 1  2  3  4   5   6   7   8   9   10  11  12
	ymon=0.5+days/30.
	call subgecrz(ymon,rzi,geci)
	write(*,82)	ayear,amn,ady,irz,irzi,geci
	write(12,82)	ayear,amn,ady,irz,irzi,geci
	enddo     ! end daily cycle
	ENDDO			 ! end monthly cycle
   71	CONTINUE ! END year-to-year cycle
   73	close(unit=11)
C
C ========================================
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=12)
	pause ' '
	STOP
	END
C
C ===============================================================
