C........................................................Apr.2012
C
C Input: TECeff calculated with Cv along the Ne(h) profile
C including ratio ov volume in shell of altitude = 200 km in [0 20,200]km
C Ne coefficients Pi * dlat, dlat= 2.5 deg (const km size)
C Pi(lat) = (dlon1+dlon2)/2, lat = -90.0,-87.5,...,90.0 [0,1,...,71]
C
C                                                        Dec 2011
C........................................................Aug 2012
C GEC=IRI model predictions for each month/year DY=15
C
C Add GEC calculation for ut=24h
C Add daily rate-of-change, daily mean GEC -> OUTFILE2
C
C T.L.Gulyaeva...........................................July 2011
C 
      PROGRAM MAPGEC7I
C----------------------------------------------------------------
C Select all latitudes: res1=-87.5N,-85N,,,,-5N,00,5,...,87.5 
C                        
C each line in input file for TEC at:[-180, -165,...0,15E,30E,...,165E]
C separate files for UT=0,1,2,3,...23hUT
C Produce GYRMNDY.res files 	 (UT GEC)
C output array: res(72)
C program for EXTRACTING FROM "uhrgdoy0.iYR" ionex_TEC data 
C Output: GYRMNDY.res data for day into annual file gecyr.br
C all results for given year, includint YRMNDY  GEC(t), t=0,1,...,23 UT + daily mean, GEC(t)=GEC/1.E+32, GECU
C outfile='gecyr.br' 
C if input file jplg (2h UT step), linear interpolation is applied for 1h UT results
C
C*********TEST
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*80 INFILE,OUTFILE,OUTFILE2
	CHARACTER*4 AYEAR
c//	CHARACTER*131 txt
	character*2 ayr,amn,dy1,ady,aut,dy2
	character*3 aday
	integer*2 iidy,iyr,imn,iut
	dimension itxx(0:72),im(12),itxx0(0:72),rtav(72)
	+,gecoef(36),iamp(0:7)
	dimension res(72),rgec(0:24),igec(0:24)
c//	+,iroc(0:24)
     +,pgec(0:24) ! prec.day
	     COMMON  /CONST/UMR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C	! 87.5,85,...,2.5,0
	DATA GECOEF/	
     + .3365878E+10,.1009411E+11,.1680663E+11,.2349024E+11,.3012725E+11
     +,.3670448E+11,.4321305E+11,.4963855E+11,.5597066E+11,.6219654E+11
     +,.6830311E+11,.7428008E+11,.8011609E+11,.8579922E+11,.9131990E+11
     +,.9666696E+11,.1018298E+12,.1067996E+12,.1115659E+12,.1161195E+12
     +,.1204528E+12,.1245565E+12,.1284233E+12,.1320460E+12,.1354173E+12
     +,.1385300E+12,.1413796E+12,.1439603E+12,.1462664E+12,.1482942E+12
     +,.1500393E+12,.1514989E+12,.1526697E+12,.1535495E+12,.1541373E+12
     +,.1544317E+12/

C
	IRUN=0
c	comp='          '

	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
c
118	format(A4)
c	pause  ' '
	WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
CTEMP	AYEAR='2012'
	ayr=ayear(3:4)
	read(ayr,*) ryr 
      iyr=int(ryr)
	read(ayear,*) year
C
	imn=0
C Mn-to-mn cycle
  128	imn=imn+1
	if (imn.gt.12) goto 35
	call blet2(imn,AMN)
c
crem      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
crem      READ(*,'(A)') AMN
crem	read(amn,*) xmn
crem	imn=int(xmn)
c//         WRITE(*,'(\A\)') ' ENTER <DY1>,<DY2> OF INPUT FILE='
c//	      READ(*,'(A)') DY1,DY2

	DY1='15'
	DY2='15'
	read(dy1,*) xdy
	idy1=int(xdy)
	read(dy2,*) xdy2
	idy2=int(xdy2)
CC??	nrdy2=idy2

c outfiles =================================
       outfile2='gecsYR.src' ! 3h Amplitude of GEC
	outfile='esYRmed.txt'
      outfile(3:4)=ayr
c//	outfile(5:6)=amn
	outfile2(5:6)=ayr	 
      		OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
	OPEN(13,FILE=OUTFILE2,ACCESS='APPEND')
CC CALCULATION OF DAY OF YEAR	(LDA)
	iiyr=int(year)
	if(int(year/4.)*4.eq.iiyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
c	xdy=1.      ! start day-of-month
C
C Start input for given UT:++++++++++++++++++++
C

C Cycle day-to-day +++++++++++++++++++++++++++++
  700	iidy=int(xdy)
	do n=0,23
	rgec(n)=0.
	enddo
	call blet2(iidy,ADY)
C
C
	lda=ndoy(iyr,imn,iidy)
	daynr=float(lda)
  178	call blet3(lda,ADAY)

c//	infile='jplg0010.05i'			 !!!!!!!! 
      infile='d:\web\des\YR\esMNDYUT.sYR'
C
 
      infile(12:13)=ayr
	infile(17:18)=amn
	infile(19:20)=ady
	infile(25:26)=ayr
C
c   11	continue     ! 
c   27 format(6X,F3.1)

c ***************************************************************
D start cycle on hr-to-hr input:
	DO 775 iut=0,23
 	rut=float(iut)	
	call blet2(iut,AUT)
	infile(21:22)=aUT
		      OPEN(111,FILE=INFILE)

   80	GEC=0.
	do k=0,72
 	itxx0(k)=0.		! prec. lati TECeff
	enddo
C
D start cycle on glatitudes:
	glati=-90.0
	DO 777 lat=1,72	   ! Start cycle on glati 
	glati=glati+2.5

	res(lat)=0.        ! GEC for each glat
	do k=0,72
 	itxx(k)=0.		! curr. lati TECeff
	enddo
C Select coefficient:
	if (glati.le.0) then
	 acoef=gecoef(lat)
	else
	 acoef=gecoef(73-lat)
	endif
C++++++++++++++++++
	if(lat.eq.72) then
	goto 171			   ! for glat=90.0
	endif
C read  TECeff for current lati
	READ (111,187,END=33,ERR=2) (itxx(k),k=0,72) 
  187	format(73(1X,I4))
c  88	continue
c   85	continue

C++++++++++++++++++
C
C Select values for Long=-180,-165,...0,15,30,..,165...!!!!!!!!!!!!:
C
171	nlon=-1
C
 	sum=0.
	do 776 il=-180,175,5     ! for long-cycle
	nlon=nlon+1
	glong=float(il) 
cc=	if (glong.lt.0.) glong=glong+360.        
C
cc=	ires(nlati,iidy,ii)=itxx(nlon)
C++++++++
		if(lat.eq.1) then
 	rtav(nlon+1)=(itxx(nlon)+itxx(nlon+1))/2.
	goto 172
	endif

		if(lat.eq.72) then
 	rtav(nlon+1)=(itxx0(nlon)+itxx0(nlon+1))/2.
	goto 172
	endif
C
	rtav(nlon+1)=(itxx0(nlon)+itxx0(nlon+1)+itxx(nlon)+itxx(nlon+1))/4.
c//      isum=isum+itxx(nlon)
  172    sum=sum+rtav(nlon)
C++			 
C
 776	continue ! long cycle
	res(lat)=sum*1.0E+15*acoef
 182	format(3A2,24(1X,I4))							
 121 	GEC=GEC+res(lat)
	do i=0,72
	itxx0(i)=itxx(i)  ! prec. lati TEC
	itxx(i)=0.
	enddo
 777  continue  ! lati cycle

C --------------- 
C OUTPUT OF RESULTS
  9	continue
 176  FORMAT(1X,I2,2X,E12.6)
c	do kk=1,72
c1	write(*,176) iut,GEC
c1	write(12,176) iut,GEC
c	enddo
	rgec(iut)=GEC/1.0E+32
 
  775 continue   ! End calculation for given UT
C Continue to the next UT hr :
  32		irun=irun+1 
c??	iutend=iruns
c??	      if (irun.lt.iutend) goto 80 ! continue to the next UT hr =>>>>
C

C Output of daily results
C
C
	sum=0.
	do i=0,23           
	if (i.lt.24) sum=sum+rgec(i) ! aver using UT=0,...,23 h
	igec(i)=nint(rgec(i)*100.)
	pgec(i)=rgec(i)    ! keep results for prec.day+++++++++++++++++++++
c-	if (i.lt.24) iroc(i)=nint((rgec(i+1)-rgec(i))*100.) ! rate-of-change
	enddo
	sum=sum/24. ! aver using UT=0,...,23 h
c-	iroc(24)=nint(sum*100)
	iaver=nint(sum*100.) 
C
C      Add output of 4 title lines
c//	IF (iidy.eq.1) THEN
c//	txt(1:3)='GEC'
c//	write(12,275) txt
c//	write(*,275) txt
  275 format(A3)
c//	WRITE(12,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
c//	txt(1:9)='YYMMDD|UT'
c//	do k=0,24
c//	iroc(k)=k
c//	enddo
  276 format(A9,24(I2,3X))	
c//      write(*,276) txt,(iroc(k),k=0,23)
c//	write(12,276) txt,(iroc(k),k=0,23)
c//	txt(1:50)='--------------------------------------------------'
c//	txt(51:100)='--------------------------------------------------'
c//	txt(101:131)='--------------------------     '
  274 format(A131)
c//	write(12,274) txt
c//	write(*,274) txt
c//	ENDIF
C
c//	write(*,177) ayr,amn,ady,(igec(i),i=0,23)  ! GEC
	write(*,177) amn,(igec(i),i=0,23)  ! GEC
	write(12,177) amn,(igec(i),i=0,23)
 177  format(A2,24(1X,I4))

C+++++++++++++++++++++++++++++++++++++++++++++++
Ctemp Produce 3-h UT amplitude of GEC
C
	do i=0,7
	i1=i*3
	xmin=9999.
	xmax=0.
C
	do k=1,3
	if (rgec(i1+k-1).lt.xmin) xmin=rgec(i1+k-1)	  ! 3h Amplitude
	if (rgec(i1+k-1).gt.xmax) xmax=rgec(i1+k-1)
	enddo
	iamp(i)=nint((xmax-xmin)*100.)
	enddo
	write(*,277) ayr,amn,ady,(iamp(i),i=0,7),iaver	 ! 3h Amplitude
	write(13,277) ayr,amn,ady,(iamp(i),i=0,7),iaver
 277  format(3A2,8(1X,I4),2X,I4)
C	pause ' '
C 
c//      xdy=xdy+1.
		irun=0
cc=	irun=irun+1
c	pause ' '
	close(unit=111)
c//	iidy=int(xdy)
c//	if ((iidy.le.idy2).and.(idy1.lt.idy2)) then
c//	goto 700                ! continue for the next day of month
c//	else
		goto 128	   ! next mn
c//	endif
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35
      endif

   33	continue
c//      if ((iidy.le.idy2).and.(idy1.lt.idy2)) goto 32
   35      write(*,*) infile,outfile
c//	write(*,*) irun
 	close (unit=12)
	close (unit=13)
      pause ' ' 
	
      STOP
       END

C***********************************************************
