      program dgecpredict
C..............................................................May 2023
C Add S-36 dGEC predict
C..............................................................Apr 2023
C Epstein step function for positive DGECp and negative DGECn
C
         DIMENSION time(0:60),res(0:60)
	CHARACTER*64 OUTFILE
       COMMON/ARGEXP/ARGMAX
	ARGMAX=88.0
	outfile='dgecpredict3.txt'
	OPEN(11,file=outfile,access='APPEND')
C Te-MAXIMUM based on JICAMARCA and ARECIBO data 
C      AHH(2)=HPOL(HOUR,HMAXD,HMAXN,SAX200,SUX200,1.,1.)
C Example:		2023.02.26-28 1st peak
c      ktmax=25  ! t=0(dGECmax peak)
c	kt1=18
c	kt2=38 ! DGEC=0
C Example:		2023.03.23-25 1st peak
c      ktmax=23  ! t=0(dGECmax peak)
c	kt1=19
c	kt2=30 ! DGEC=0
C Example:		2023.04.23-25 1st peak
      ktmax=23  ! t=0(dGECmax peak)	 obs
	kt1=16
	kt2=27 ! DGEC=0
C Example:		2023.08.04-06 1st peak
c      ktmax=24  ! t=0(dGECmax peak)
c	kt1=12
c	kt2=31 ! DGEC=0
C Example:		2022.02.03-05 1st peak
c      ktmax=0  ! t=0(dGECmax peak)
c	kt1=-6
c	kt2=5 ! DGEC=0
C Example:		2022.02.03-05 2nd peak
C-      ktmax=-2
C-	kt1=-12
C-	kt2=3 ! DGEC=0
C
C Example:		2023.04.23
C      ktmax=3
C	kt1=-12
C	kt2=6 ! DGEC=0
c	SA=(kt1+ktmax)/2.   !(-12-4)/2=-8.
c	SU=(ktmax+kt2)/2.   !(3-4)/2.=-0.5
C times +12h
C      jtmax=ktmax+12
c	jt1=kt1+12
c	jt2=kt2+12
c	SA=(jt1+jtmax)/2. 
c	SU=(jtmax+jt2)/2.
C
C	TMAX=8.8  !max 'day'
C	TMAX=11.4  !max 'day' 1st dGECmax 27.02.2023 obs
c	TMAX=9.4  !max 'day' 1st dGECmax 24.03.2023 obs
	TMAX=11.5  !max 'day' 1st dGECmax 24.04.2023 obs
c	TMAX=12.3  !max 'day' 1st dGECmax 05.08.2023
C	TMAX=26.5  !max 'day' 2nd  dGECmax
	TMIN=0.5	 !min 'night'
	do k=0,47
	time(k)=0.
	res(k)=0.
	enddo
	write(*,31) kt1,ktmax,kt2,TMAX,0.5
      write(11,31) kt1,ktmax,kt2,TMAX,0.5
C
   30 format(1X,F5.1,1X,F6.2)
   31 format(1X,' tstart=',1X,I3,' tmax=',1X,I3,' tGEC0=',1X,I3
     +,' dGECmax=',F6.2,' dGEC0=',F6.2)
   32 format(1X,' tGEC0=',1X,I3,' tmin=',1X,I3,' tend=',1X,I3
     +,' dGECmin=',F6.2,' dGEC0=',F6.2)
C Correct time >=0
C++	  k1=kt1+12
C++	k2=kt2+12
C++	kmax=ktmax+12
	  k1=kt1
	k2=kt2
	kmax=ktmax
 	SA=(k1+kmax)/2. 
 	SU=(kmax+k2)/2.

	do kt=k1,k2
	HOUR=float(kt)
C++	time(kt)=HOUR-12.
	time(kt)=HOUR
	res(kt)=HPOL(HOUR,TMAX,0.5,SA,SU,1.,1.)
	write(*,30) time(kt),res(kt)
	write(11,30) time(kt),res(kt)
	ENDDO
C dGEC negative
C Example:		2023.02.26-28 1st peak false alarm 
c      kt1=39  ! DGEC=0 +1
c	ktmin=41
c	kt2=60
C Example:		2023.03.23-25 1st peak false alarm 
c      kt1=31  ! DGEC=0 +1
c	ktmin=39
c	kt2=56
C Example:		2023.04.23-25 1st peak false alarm 
      kt1=28  ! DGEC=0 +1
	ktmin=48
	kt2=60
C Example:		2023.08.04-06 1st peak false alarm 
c      kt1=32  ! DGEC=0 +1
c	ktmin=43
c	kt2=55
C Example:		2022.02.03-05 1st peak false alarm 
C      kt1=6  ! DGEC=0
C	ktmin=15
C	kt2=23
C      kt1=7  ! DGEC=0
c      kt1=4  ! DGEC=0
C	ktmin=26
C	ktmin=10
C	kt2=25 
C	k1=kt1+12
C	kmin=ktmin+12
C	k2=kt2+12
	k1=kt1
	kmin=ktmin
	k2=kt2
	SA=(k1+kmin)/2.   !
	SU=(kmin+k2)/2.   !
C-	TMAX=-0.5
C	TMIN=-30.6
C	TMIN=-30.6
C	TMIN=-9.1	 !min 'night' 1st dGECmin false alarm 27.02.2023
c	TMIN=-19.1	 !min 'night' 1st dGECmin false alarm 24.03.2023 obs
	TMIN=-29.4	 !min 'night' 1st dGECmin false alarm 24.04.2023  obs
C	TMIN=-9.6	 !min 'night' 1st dGECmin false alarm 05.08.2023
CC	TMIN=-15.2	 !min 'night' 2nd dGECmin
C
      write(*,32) kt1,ktmin,kt2,TMIN,-0.5
	write(11,32) kt1,ktmin,kt2,TMIN,-0.5
	do k=0,47
	time(k)=0.
	res(k)=0.
	enddo
	do kt=k1,k2
	HOUR=float(kt)
c	time(kt)=HOUR-12.
	time(kt)=HOUR
	res(kt)=HPOL(HOUR,TMIN,-0.5,SA,SU,1.,1.)
	write(*,30) time(kt),res(kt)
	write(11,30) time(kt),res(kt)
	ENDDO

	close(11)
	pause ' '
	STOP
	END
C
C==============================
      FUNCTION HPOL(HOUR,TW,XNW,SA,SU,DSA,DSU)            
C-------------------------------------------------------
C PROCEDURE FOR SMOOTH TIME-INTERPOLATION USING EPSTEIN  
C STEP FUNCTION AT SUNRISE (SA) AND SUNSET (SU). THE 
C++++++++ 
C STEP-WIDTH FOR SUNRISE IS DSA AND FOR SUNSET DSU.
C TW,NW ARE THE DAY AND NIGHT VALUE OF THE PARAMETER TO 
C BE INTERPOLATED. SA AND SU ARE TIME OF SUNRIES AND 
C SUNSET IN DECIMAL HOURS.
C BILITZA----------------------------------------- 1979.
C-        IF(ABS(SU).GT.25.) THEN
C-                IF(SU.GT.0.0) THEN
C-                        HPOL=TW
C-                ELSE
C-                        HPOL=XNW
C-                ENDIF
C-                RETURN
C-        ENDIF
      HPOL=XNW+(TW-XNW)*EPST(HOUR,DSA,SA)+
     &  (XNW-TW)*EPST(HOUR,DSU,SU) 
      RETURN          
      END       
C=========================
        REAL FUNCTION EPSTEP ( Y2, Y1, SC, HX, X)
C---------------------------------------------- STEP FROM Y1 TO Y2      
        EPSTEP = Y1 + ( Y2 - Y1 ) * EPST ( X, SC, HX)
        RETURN
        END
C
C=========================
        REAL FUNCTION EPST ( X, SC, HX )
C -------------------------------------------------------------- STEP
        COMMON/ARGEXP/ARGMAX
        D1 = ( X - HX ) / SC
        IF (ABS(D1).LT.ARGMAX) GOTO 1
        IF (D1.GT.0.0) THEN
          EPST = 1.
        ELSE
          EPST = 0.
        ENDIF
        RETURN
1       EPST = 1. / ( 1. + EXP( -D1 ))
        RETURN
        END
