      program geccoef2h1x1
C.............................................................Sep 2023
C Maps 1x1
C.............................................................May 2023
C TEC at (lat,long) of grid points
C.............................................................Apr.2012
C Coef. for TECeff = mean TECeff for a sell
C
C ............................................................Feb.2012
C TECij = mean TEC for a cell
C dlat=2.5, lati={-88.75,88.75] step=2.5,
C dlon=5.0. long=[-177.5,177.5] step=5
C
	CHARACTER*16 FILNAM
C
C calculate coefficient for TECi due to Afraimovich et al., 
C weighted by Cv=7.52
c
C teta=glati, fi=glong, dteta=2.5deg, dfi=5deg.
	FILNAM='geccoef2h1x1.txt'
C--	h=0.
	h=450.
	RE=6370.
	RH2=(RE+h)**2
	PI=ATAN(1.0)*4.
        UMR=PI/180.
	dtetar=1.0*umr	  ! step lati
	dfir=1.*umr		  ! step longi
	ddfirtet=dtetar*dfir
C-	call subdist1(0.,0.,2.5,0.,h,dkm0) ! distance for dteta=2.5
C 
C      OPEN(12,FILE=FILNAM,ACCESS='APPEND')
      OPEN(12,FILE=FILNAM)
	glat=-90.5
CC
CC
	DO 50 i=1,180			 ! cycle along Latitudes -89.5:1:89.5
	glat=glat+1.0
	glat_pre=glat-0.5
	glat_nex=glat+0.5
      dsin1=abs(sin(glat_pre*umr)-sin(glat_nex*umr))
	dsupc1=dfir*dsin1*RH2     ! Manuel
C	      dsin=abs(sin(glat2*umr)-sin(glat1*umr))
C	dsupc=dfir*dsin*RH2     ! Manuel
C??	scell=cos(dtetar)*ddfirtet*RH2
Cpre      scell=dsupc
      scell=dsupc1
C-	if (i.eq.72) then
C-	dkm2=0.
C-	goto 26
C-	endif
C-   25	call subdist1(glat2,0.,glat2,5.0,0.,dkm2)	! distance for glat2
C-   26	del=(dkm1+dkm2)/2.
C-	scell=del*dkm0
cNOT	gcoef=scell*7.52
      gcoef=scell
	write(*,*) glat,gcoef
	write(12,*) glat,gcoef
C	glat=glat+1.0
   50 continue
C
	close(unit=12)
	pause ' '
	stop

C	

	hstar=150.
	do i=1,10
      e1=(1.+exp(-hstar/300.))
	e2=(1.+exp(-(hstar/100.-30.)/3.))
	ro1=1./e1+1./e2
	ro=5-4*ro1
	write (*,*) hstar,ro
c	hstar=hstar+300.
	hstar=hstar+50.
	enddo
	stop
	end
